<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 499.1   Patch: 4                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function NewsStory
 * A function to show a news story
 * @author Philipp Louis Esselbach
 */
function NewsStory( $page )
{
	global $config, $database, $templates, $system, $security, $preferences, $user, $ipaddr, $uwrapper;
	list( $page_query, $opt ) = $system -> getpages( $page, 0 );
	
	if( !isset( $_POST[ 'title' ] ) )
	{
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_views = newsstory_views + 1 WHERE newsstory_seo = '" . $page_query . "' AND (newsstory_website = '0' OR newsstory_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
		$templates -> initgzip();
	}
	
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_header_alt','site_footer_alt','site_advertisement_header','site_advertisement_list','site_advertisement_footer','site_block','site_login_anon','site_login_user','site_invalid_form','news_story_trackback_received','news_header','news_story_header','news_story_teaserimage','news_story_extended','news_story_link','news_story_extended_nav','news_story_extended_nav_previous','news_story_extended_nav_next','news_story_extended_advertisement','news_story_extended_social','news_story_rating_1star','news_story_rating_2stars','news_story_rating_3stars','news_story_rating_4stars','news_story_rating_5stars','news_story_editlink','news_story_tags','news_story_tags_list','news_story_error_na','news_story_rating_form','news_story_poll_header','news_story_poll_option_radio','news_story_poll_option_checkbox','news_story_poll_footer','news_story_poll_results_header','news_story_poll_results_list','news_story_poll_results_footer','news_story_trackback_header','news_story_trackback_list','news_story_trackback_na','news_story_trackback_footer','news_story_related_header','news_story_related_list','news_story_password','news_story_related_footer','news_story_comment_pagenav_header','news_story_comment_pagenav_first','news_story_comment_pagenav_previous','news_story_comment_pagenav_link','news_story_comment_pagenav_selected','news_story_comment_pagenav_next','news_story_comment_pagenav_last','news_story_comment_pagenav_footer','news_story_comment_manage_header','news_story_comment','news_story_comment_plonked','news_story_comment_userposts','news_story_comment_userregdate','news_story_comment_userlocation','news_story_comment_usertitle','news_story_comment_usertitle_anon','news_story_comment_usertitle_admin','news_story_comment_usertitle_moderator','news_story_comment_usertitle_subscriber','news_story_comment_usertitle_banned','news_story_comment_avatar','news_story_comment_signature','news_story_comment_profile','news_story_comment_messageicon','news_story_comment_options','news_story_comment_options_edit','news_story_comment_options_admin','news_story_comment_manage_footer','news_story_comment_form','news_story_comment_form_anon','news_story_comment_form_securitycode','news_story_comment_form_icon','news_story_comment_form_iconrow','news_story_comment_form_signature','news_story_comment_form_external','news_story_error_trackbackflood','news_story_error_trackbackdisabled','news_story_error_nostory','news_story_error_password','news_story_footer','news_layout_extended_story'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );
	
	if( !isset( $_POST[ 'input_security_hash' ] ) )
	{
		session_start();
		$insert[ 'news_security_hash' ] = md5( rand( 1, 32768 ) );
		$_SESSION[ 'news_security_hash' ] = $insert[ 'news_security_hash' ];
	}
	else
	{
		$insert[ 'news_security_hash' ] = $security -> checkvar( $_POST[ 'input_security_hash' ] );
	}
	
	if( $user[ 'user_status' ] == 1 )
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '3')";
		$newsstory_status_alt = "(newsstory_status = '0' OR newsstory_status = '1')";
	}
	elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '2' OR newsstory_status = '3' OR newsstory_status = '4')";
		$newsstory_status_alt = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '2' OR newsstory_status = '4')";
	}
	elseif( $user[ 'user_status' ] == 6 )
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '3' OR newsstory_status = '4')";
		$newsstory_status_alt = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '4')";
	}
	else
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '3')";
		$newsstory_status_alt = "newsstory_status = '0'";
	}
	
	$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_channels, newsstory_title, newsstory_seo, newsstory_story, newsstory_extendedstory, newsstory_link, newsstory_description, newsstory_keywords, newsstory_tags, newsstory_teaser, newsstory_comments, newsstory_thread, newsstory_allowcomments, newsstory_status, newsstory_password, newsstory_date, newsstory_poll, newsstory_pollresults, newsstory_fields, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_seo = '" . $page_query . "' AND " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
	
	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_author' ], $insert[ 'newsstory_channels' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_story' ], $insert[ 'newsstory_extendedstory' ], $insert[ 'newsstory_link' ], $insert[ 'newsstory_description' ], $insert[ 'newsstory_keywords' ], $insert[ 'newsstory_tags' ], $insert[ 'newsstory_teaser' ], $insert[ 'newsstory_comments' ], $insert[ 'newsstory_thread' ], $insert[ 'newsstory_allowcomments' ], $insert[ 'newsstory_status' ], $insert[ 'newsstory_password' ], $insert[ 'newsstory_date' ], $insert[ 'newsstory_poll' ], $insert[ 'newsstory_pollresults' ], $insert[ 'newsstory_fields' ], $insert[ 'newsstory_views' ], $insert[ 'newsstory_rating' ], $insert[ 'newsstory_votes' ], $insert[ 'newsstory_source' ], $insert[ 'newsstory_sourceid' ] ) = $database -> dbrow( $query );
		
		if( $insert[ 'newsstory_status' ] == 3 )
		{
			$newsstory_password = ( isset( $_POST[ 'newsstory_password' ] ) ) ? $security -> checkvare( $_POST[ 'newsstory_password' ] ) : "" ;
			$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
			
			if( !$newsstory_password )
			{
				$newsstory_notice = $templates -> exectemplate( $main_templates[ 'news_story_password_html' ], $main_templates[ 'news_story_password_php' ], $insert );
			}
			elseif( $newsstory_password != $insert[ 'newsstory_password' ] )
			{
				$newsstory_notice = $templates -> exectemplate( $main_templates[ 'news_story_error_password_html' ], $main_templates[ 'news_story_error_password_php' ], $insert );
			}
			else
			{
				session_start();
				
				if( $_SESSION[ 'news_security_hash' ] != $input_security_hash )
				{
					echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
					exit;
				}
			}
		}
		
		$id = $security -> checknum( $insert[ 'newsstory_id' ] );
		
		if( ( isset( $_POST[ 'title' ] ) ) and( isset( $_POST[ 'url' ] ) ) and( isset( $_POST[ 'excerpt' ] ) ) and( isset( $_POST[ 'blog_name' ] ) ) )
		{
			if( $preferences[ 'news_allow_trackbacks' ] )
			{
				$input_blogname = ( isset( $_POST[ 'blog_name' ] ) ) ? $security -> checkvar( urldecode( $_POST[ 'blog_name' ] ) ) : "" ;
				$input_title = ( isset( $_POST[ 'title' ] ) ) ? $security -> checkvar( urldecode( $_POST[ 'title' ] ) ) : "" ;
				$input_url = ( isset( $_POST[ 'url' ] ) ) ? $security -> checkvar( urldecode( $_POST[ 'url' ] ) ) : "" ;
				$input_description = ( isset( $_POST[ 'excerpt' ] ) ) ? $security -> checkvar( urldecode( $_POST[ 'excerpt' ] ) ) : "" ;
				$query = $database -> dbquery( "SELECT newstrackback_date FROM " . DB_PREFIX . "esselbach_ct_newstrackbacks WHERE newstrackback_postip = '" . $ipaddr . "'" );
				list( $newstrackback_date ) = $database -> dbrow( $query );
				$newstrackback_olddate = strtotime( $newstrackback_date );
				$newstrackback_currentdate = mktime();
				$newstrackback_flooddate = $newstrackback_olddate + $preferences[ 'news_max_trackbacktime' ];
				
				if( $newstrackback_currentdate < $newstrackback_flooddate )
				{
					header( "content-type: text/xml" );
					echo $templates -> exectemplate( $main_templates[ 'news_story_error_trackbackflood_html' ], $main_templates[ 'news_story_error_trackbackflood_php' ], $insert );
					exit;
				}
				
				$query = $database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newstrackbacks (newstrackback_id, newstrackback_story, newstrackback_sitename, newstrackback_title, newstrackback_url, newstrackback_description, newstrackback_date, newstrackback_approved, newstrackback_postip, newstrackback_editip, newstrackback_editadmin) VALUES (NULL, '" . $id . "', '" . $input_blogname . "', '" . $input_title . "', '" . $input_url . "', '" . $input_description . "', now(), '0', '" . $ipaddr . "', '', '')" );
				header( "content-type: text/xml" );
				echo $templates -> exectemplate( $main_templates[ 'news_story_trackback_received_html' ], $main_templates[ 'news_story_trackback_received_php' ], $insert );
				exit;
			}
			else
			{
				header( "content-type: text/xml" );
				echo $templates -> exectemplate( $main_templates[ 'news_story_error_trackbackdisabled_html' ], $main_templates[ 'news_story_error_trackbackdisabled_php' ], $insert );
				exit;
			}
		}
		
		if( $preferences[ 'news_allow_rating' ] and $insert[ 'newsstory_votes' ] )
		{
			if( $insert[ 'newsstory_rating' ] == 5 )
			{
				$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_5stars_html' ], $main_templates[ 'news_story_rating_5stars_php' ], $insert );
			}
			elseif( $insert[ 'newsstory_rating' ] == 4 )
			{
				$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_4stars_html' ], $main_templates[ 'news_story_rating_4stars_php' ], $insert );
			}
			elseif( $insert[ 'newsstory_rating' ] == 3 )
			{
				$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_3stars_html' ], $main_templates[ 'news_story_rating_3stars_php' ], $insert );
			}
			elseif( $insert[ 'newsstory_rating' ] == 2 )
			{
				$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_2stars_html' ], $main_templates[ 'news_story_rating_2stars_php' ], $insert );
			}
			elseif( $insert[ 'newsstory_rating' ] < 2 )
			{
				$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_1star_html' ], $main_templates[ 'news_story_rating_1star_php' ], $insert );
			}
		}
		else
		{
			$insert[ 'newsstory_rating_line' ] = "";
		}
		
		$insert[ 'param_ext' ] = $preferences[ 'param_ext' ];
		$insert[ 'param_ct' ] = $preferences[ 'param_ct' ];
		$insert[ 'param_action' ] = $preferences[ 'param_action' ];
		$insert[ 'param_page' ] = $preferences[ 'param_page' ];
		$insert[ 'param_id' ] = $preferences[ 'param_id' ];
		
		if( $user[ 'user_status' ] == 2 and $insert[ 'newsstory_author' ] == $user[ 'user_name' ] )
		{
			$insert[ 'newsstory_edit' ] = $templates -> exectemplate( $main_templates[ 'news_story_editlink_html' ], $main_templates[ 'news_story_editlink_php' ], $insert );
		}
		else
		{
			$insert[ 'newsstory_edit' ] = "";
		}
		
		if( $insert[ 'newsstory_tags' ] )
		{
			$tags = explode( ",", $insert[ 'newsstory_tags' ] );
			$tags_array = array();
			
			foreach( $tags as $insert[ 'newsstory_tag' ] )
			{
				$insert[ 'newsstory_tag_seo' ] = $system -> doseo( $insert[ 'newsstory_tag' ] );
				$tags_array[ ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_list_html' ], $main_templates[ 'news_story_tags_list_php' ], $insert );
			}
			
			$insert[ 'newsstory_tags_list' ] = implode( ",", $tags_array );
			$insert[ 'newsstory_tags' ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_html' ], $main_templates[ 'news_story_tags_php' ], $insert );
		}
		
		if( $insert[ 'newsstory_fields' ] )
		{
			$input_fields_array = explode( "|", $insert[ 'newsstory_fields' ] );
			$extra = 0;
			
			for( $i = 0; $i < 24; $i++ )
			{
				$extra++;
				$insert[ 'newsstory_extra' . $extra ] = $system -> decode( $input_fields_array[ $i ] );
			}
		}
		else
		{
			for( $i = 1; $i < 25; $i++ )
			{
				$insert[ 'newsstory_extra' . $i ] = "";
			}
		}
		
		if( $insert[ 'newsstory_teaser' ] )
		{
			$insert[ 'newsstory_teaserimage' ] = $templates -> exectemplate( $main_templates[ 'news_story_teaserimage_html' ], $main_templates[ 'news_story_teaserimage_php' ], $insert );
		}
		else
		{
			$insert[ 'newsstory_teaserimage' ] = "";
		}
		
		if( $preferences[ 'website_advertisement_middle' ] )
		{
			$insert[ 'advertisement_middle' ] = $preferences[ 'website_advertisement_middle' ];
			$insert[ 'newsstory_advertisement' ] = $templates -> exectemplate( $main_templates[ 'news_story_extended_advertisement_html' ], $main_templates[ 'news_story_extended_advertisement_php' ], $insert );
		}
		else
		{
			$insert[ 'newsstory_advertisement' ] = "";
		}
		
		if( $preferences[ 'news_social' ] )
		{
			$insert[ 'newsstory_title_encoded' ] = urlencode( htmlspecialchars( $insert[ 'newsstory_title' ] ) );
			$insert[ 'newsstory_url_encoded' ] = urlencode( htmlspecialchars( $insert[ 'site_url' ] . "/contentteller" . $insert[ 'param_ext' ] . $insert[ 'param_ct' ] . "news" . $insert[ 'param_action' ] . "story" . $insert[ 'param_page' ] . $insert[ 'newsstory_seo' ] . ".html" ) );
			$insert[ 'newsstory_social' ] = $templates -> exectemplate( $main_templates[ 'news_story_extended_social_html' ], $main_templates[ 'news_story_extended_social_php' ], $insert );
		}
		else
		{
			$insert[ 'newsstory_social' ] = "";
		}
		
		if( $preferences[ 'news_forum_comments' ] and $insert[ 'newsstory_thread' ] )
		{
			$insert[ 'newsstory_comments' ] = $uwrapper -> getcomment( $insert[ 'newsstory_thread' ] );
		}
			
		if( $insert[ 'newsstory_link' ] )
		{
			$insert[ 'newsstory_extendedstory' ] .= $templates -> exectemplate( $main_templates[ 'news_story_link_html' ], $main_templates[ 'news_story_link_php' ], $insert );
		}
		
		if( $preferences[ 'news_remove_nofollow' ] )
		{
			if( $preferences[ 'news_remove_nofollow_age' ] )
			{
				$news_nofollow_age = date( "Y-m-d H:i:s", mktime() - 86400 * $preferences[ 'news_remove_nofollow_age' ] );
				if ( $insert[ 'newsstory_date' ] > $news_nofollow_age )
				{
					$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
					$insert[ 'newsstory_extendedstory' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_extendedstory' ] );
				}
			}
			else 
			{
				$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
				$insert[ 'newsstory_extendedstory' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_extendedstory' ] );
			}
		}

		$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
		$insert[ 'newsstory_author' ] = htmlspecialchars( $insert[ 'newsstory_author' ] );
		$insert[ 'newsstory_month_id' ] = $system -> getmonth( $insert[ 'newsstory_date' ] );
		$insert[ 'newsstory_month' ] = $system -> convertdate( $insert[ 'newsstory_date' ], "%B %Y", $preferences[ 'website_timezone' ] );
		$insert[ 'newsstory_date' ] = $system -> convertdate( $insert[ 'newsstory_date' ], $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );
		
		$news_story = $templates -> exectemplate( $main_templates[ 'news_story_extended_html' ], $main_templates[ 'news_story_extended_php' ], $insert );
		$input_author = $database -> dbescape( $user[ 'user_username' ] );
		
		if( $insert[ 'newsstory_poll' ] )
		{
			$input_poll_array = explode( "|", $insert[ 'newsstory_poll' ] );
			
			if( $insert[ 'newsstory_pollresults' ] )
			{
				$input_results_array = explode( "|", $insert[ 'newsstory_pollresults' ] );
			}
			else
			{
				$input_results_array = array();
			}
			
			$insert[ 'poll_question' ] = $system -> decode( $input_poll_array[ 0 ] );
			$input_poll_choice = $input_poll_array[ 1 ];
			$voted = 0;
			
			if( $preferences[ 'news_allow_unregpolls' ] or $user[ 'user_status' ] )
			{
				if( $user[ 'user_status' ] )
				{
					$query = $database -> dbquery( "SELECT newspoll_id FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $id . "' and newspoll_user = '" . intval( $user[ 'user_id' ] ) . "'" );
					$voted = $database -> dbrows( $query );
				}
				else
				{
					$uniqueid = md5( $_SERVER[ 'HTTP_USER_AGENT' ] . $ipaddr );
					$query = $database -> dbquery( "SELECT newspoll_id FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $id . "' and newspoll_uniqueid = '" . $uniqueid . "'" );
					$voted = $database -> dbrows( $query );
				}
			}
			
			if( ( !$voted and $preferences[ 'news_allow_unregpolls' ] ) or( !$voted and $user[ 'user_status' ] ) )
			{
				$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_header_html' ], $main_templates[ 'news_story_poll_header_php' ], $insert );
				
				for( $i = 1; $i < 22; $i++ )
				{
					$insert[ 'poll_option_id' ] = $i - 1;
					$insert[ 'poll_option' ] = $system -> decode( $input_poll_array[ $i ] );
					
					if( $insert[ 'poll_option' ] )
					{
						if( $input_poll_choice )
						{
							$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_option_checkbox_html' ], $main_templates[ 'news_story_poll_option_checkbox_php' ], $insert );
						}
						else
						{
							$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_option_radio_html' ], $main_templates[ 'news_story_poll_option_radio_php' ], $insert );
						}
					}
				}
				
				$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_footer_html' ], $main_templates[ 'news_story_poll_footer_php' ], $insert );
			}
			else
			{
				$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_results_header_html' ], $main_templates[ 'news_story_poll_results_header_php' ], $insert );
				$totalvotes = 0;
				
				for( $i = 0; $i < count( $input_results_array ); $i++ )
				{
					$totalvotes = $totalvotes + $input_results_array[ $i ];
				}
				
				for( $i = 2; $i < 22; $i++ )
				{
					$y = $i - 2;
					
					if( $input_poll_array[ $i ] )
					{
						$insert[ 'poll_option' ] = $system -> decode( $input_poll_array[ $i ] );
						
						if( isset( $input_results_array[ $y ] ) and $input_results_array[ $y ] )
						{
							$insert[ 'poll_votes' ] = $input_results_array[ $y ];
							$insert[ 'poll_percent' ] = 100 * $insert[ 'poll_votes' ] / $totalvotes;
							$insert[ 'poll_votebar' ] = $insert[ 'poll_percent' ] * 2;
							$insert[ 'poll_percent' ] = ceil( $insert[ 'poll_percent' ] );
						}
						else
						{
							$insert[ 'poll_votes' ] = 0;
							$insert[ 'poll_percent' ] = 0;
							$insert[ 'poll_votebar' ] = 0;
							$insert[ 'poll_percent' ] = 0;
						}
						
						$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_results_list_html' ], $main_templates[ 'news_story_poll_results_list_php' ], $insert );
					}
				}
				
				$news_story .= $templates -> exectemplate( $main_templates[ 'news_story_poll_results_footer_html' ], $main_templates[ 'news_story_poll_results_footer_php' ], $insert );
			}
		}
		
		$insert[ 'page_name' ] = $insert[ 'newsstory_title' ];
		$insert[ 'page_description' ] = htmlspecialchars( $insert[ 'newsstory_description' ] );
		$insert[ 'page_keywords' ] = htmlspecialchars( $insert[ 'newsstory_keywords' ] );
		$insert[ 'news_story_advertisement' ] = "";
		
		if( $preferences[ 'news_story_advertisement' ] )
		{
			$keywords_array = explode( ", ", $insert[ 'newsstory_keywords' ] );
			$keywords_sql_array = array();
			
			foreach( $keywords_array as $keyword )
			{
				$keywords_sql_array[ ] = "advertisement_keywords LIKE '%" . $database -> dbescape( $keyword ) . "%'";
			}
			
			$keywords_sql = implode( " OR ", $keywords_sql_array );
			
			if( $keywords_sql )
			{
				$keywords_sql = " WHERE (" . $keywords_sql . ") AND";
			}
			
			$preferences[ 'news_max_story_adv' ] = intval( $preferences[ 'news_max_story_adv' ] );
			
			if( !$preferences[ 'news_max_story_adv' ] )
			{
				$preferences[ 'news_max_story_adv' ] = 5;
			}
			
			$query = $database -> dbquery( "SELECT advertisement_id, advertisement_key, advertisement_name, advertisement_text FROM " . DB_PREFIX . "esselbach_ct_advertisements" . $keywords_sql . " advertisement_impressions > '0' AND (advertisement_website = '0' OR advertisement_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY advertisement_position LIMIT " . $preferences[ 'news_max_story_adv' ] );
			
			if( $database -> dbrows( $query ) )
			{
				$insert[ 'news_story_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_header_html' ], $main_templates[ 'site_advertisement_header_php' ], $insert );
				
				while( list( $advertisement_id, $advertisement_key, $advertisement_name, $advertisement_text ) = $database -> dbrow( $query ) )
				{
					$insert[ 'advertisement_key' ] = htmlspecialchars( $advertisement_key );
					$insert[ 'advertisement_name' ] = htmlspecialchars( $advertisement_name );
					$insert[ 'advertisement_text' ] = htmlspecialchars( $advertisement_text );
					$insert[ 'news_story_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_list_html' ], $main_templates[ 'site_advertisement_list_php' ], $insert );
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_advertisements SET advertisement_impressions = advertisement_impressions - 1, advertisement_views = advertisement_views + 1, advertisement_activity = now() WHERE advertisement_id = '" . $advertisement_id . "'" );
				}
				
				$insert[ 'news_story_advertisement' ] .= $templates -> exectemplate( $main_templates[ 'site_advertisement_footer_html' ], $main_templates[ 'site_advertisement_footer_php' ], $insert );
			}
		}
	}
	
	if( !isset( $news_story ) or( isset( $newsstory_notice ) ) )
	{
		$news_story = "";
		$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ] );
		$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ] );
		$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ] );
	}
	
	if( $preferences[ 'news_alt_site_header' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_alt_html' ], $main_templates[ 'site_header_alt_php' ], $insert );
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	}
	
	if( $preferences[ 'news_navigation' ] )
	{
		if( $news_story )
		{
			$insert[ 'news_story_header' ] = $templates -> exectemplate( $main_templates[ 'news_story_header_html' ], $main_templates[ 'news_story_header_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'news_header_html' ], $main_templates[ 'news_header_php' ], $insert );
		}
	}
	
	if( $news_story )
	{
		$insert[ 'news_story_extended' ] = $news_story;
		$insert[ 'news_story_rating_form' ] = "";
		
		if( $preferences[ 'news_allow_rating' ] )
		{
			if( $preferences[ 'news_allow_unregrating' ] or $user[ 'user_status' ] )
			{
				$votes = 0;
				
				if( $user[ 'user_status' ] )
				{
					$query = $database -> dbquery( "SELECT newsrating_id FROM " . DB_PREFIX . "esselbach_ct_newsratings WHERE newsrating_story = '" . $id . "' and newsrating_user = '" . intval( $user[ 'user_id' ] ) . "'" );
					$votes = $database -> dbrows( $query );
				}
				else
				{
					$uniqueid = md5( $_SERVER[ 'HTTP_USER_AGENT' ] . $ipaddr );
					$query = $database -> dbquery( "SELECT newsrating_id FROM " . DB_PREFIX . "esselbach_ct_newsratings WHERE newsrating_story = '" . $id . "' and newsrating_uniqueid = '" . $uniqueid . "'" );
					$votes = $database -> dbrows( $query );
				}
				
				if( !$votes )
				{
					$insert[ 'news_story_rating_form' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_form_html' ], $main_templates[ 'news_story_rating_form_php' ], $insert );
				}
			}
		}
		
		if( $preferences[ 'news_allow_trackbacks' ] )
		{
			$insert[ 'news_story_trackback' ] = $templates -> exectemplate( $main_templates[ 'news_story_trackback_header_html' ], $main_templates[ 'news_story_trackback_header_php' ], $insert );
			$query = $database -> dbquery( "SELECT newstrackback_sitename, newstrackback_title, newstrackback_url, newstrackback_description, newstrackback_date FROM " . DB_PREFIX . "esselbach_ct_newstrackbacks WHERE newstrackback_story = '" . $id . "' AND newstrackback_approved = '1'" );
			
			if( $database -> dbrows( $query ) )
			{
				while( list( $newstrackback_sitename, $newstrackback_title, $newstrackback_url, $newstrackback_description, $newstrackback_date ) = $database -> dbrow( $query ) )
				{
					$insert[ 'newstrackback_sitename' ] = htmlspecialchars( $newstrackback_sitename );
					$insert[ 'newstrackback_title' ] = htmlspecialchars( $newstrackback_title );
					$insert[ 'newstrackback_url' ] = htmlspecialchars( $newstrackback_url );
					$insert[ 'newstrackback_description' ] = htmlspecialchars( $newstrackback_description );
					$insert[ 'newstrackback_date' ] = $newstrackback_date;
					$insert[ 'news_story_trackback' ] .= $templates -> exectemplate( $main_templates[ 'news_story_trackback_list_html' ], $main_templates[ 'news_story_trackback_list_php' ], $insert );
				}
			}
			else
			{
				$insert[ 'news_story_trackback' ] .= $templates -> exectemplate( $main_templates[ 'news_story_trackback_na_html' ], $main_templates[ 'news_story_trackback_na_php' ], $insert );
			}
			
			$insert[ 'news_story_trackback' ] .= $templates -> exectemplate( $main_templates[ 'news_story_trackback_footer_html' ], $main_templates[ 'news_story_trackback_footer_php' ], $insert );
		}
		else
		{
			$insert[ 'news_story_trackback' ] = "";
		}
		
		$insert[ 'news_story_related' ] = "";
		
		if( $preferences[ 'news_related' ] and $news_story )
		{
			$query = $database -> dbquery( "SELECT newsrelated_storyid, newsrelated_author, newsrelated_title, newsrelated_seo, newsrelated_description, newsrelated_date FROM " . DB_PREFIX . "esselbach_ct_newsrelated WHERE newsrelated_story = '" . $id . "'" );
			
			if( $database -> dbrows( $query ) > 1 )
			{
				$insert[ 'news_story_related' ] = $templates -> exectemplate( $main_templates[ 'news_story_related_header_html' ], $main_templates[ 'news_story_related_header_php' ], $insert );
				
				while( list( $insert[ 'newsrelated_id' ], $insert[ 'newsrelated_author' ], $insert[ 'newsrelated_title' ], $insert[ 'newsrelated_seo' ], $insert[ 'newsrelated_description' ], $insert[ 'newsrelated_date' ] ) = $database -> dbrow( $query ) )
				{
					$insert[ 'newsrelated_title' ] = htmlspecialchars( $insert[ 'newsrelated_title' ] );
					$insert[ 'newsrelated_author' ] = htmlspecialchars( $insert[ 'newsrelated_author' ] );
					$insert[ 'newsrelated_description' ] = htmlspecialchars( $insert[ 'newsrelated_description' ] );
					$insert[ 'newsrelated_date' ] = $system -> convertdate( $insert[ 'newsrelated_date' ], $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );
					$insert[ 'news_story_related' ] .= $templates -> exectemplate( $main_templates[ 'news_story_related_list_html' ], $main_templates[ 'news_story_related_list_php' ], $insert );
				}
				
				$insert[ 'news_story_related' ] .= $templates -> exectemplate( $main_templates[ 'news_story_related_footer_html' ], $main_templates[ 'news_story_related_footer_php' ], $insert );
			}
		}
		
		if( $preferences[ 'news_story_navigation' ] )
		{
			$query = $database -> dbquery( "SELECT newsstory_title, newsstory_seo FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_id < '" . $id . "' AND " . $newsstory_status_alt . " AND (newsstory_website = '0' OR newsstory_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY newsstory_id DESC LIMIT 1" );
			
			if( $database -> dbrows( $query ) )
			{
				list( $previous_title, $previous_seo ) = $database -> dbrow( $query );
				$insert[ 'newsstory_nav_seo' ] = $previous_seo;
				$insert[ 'newsstory_nav_title' ] = htmlspecialchars( $previous_title );
				$insert[ 'newsstory_previous_story' ] = $templates -> exectemplate( $main_templates[ 'news_story_extended_nav_previous_html' ], $main_templates[ 'news_story_extended_nav_previous_php' ], $insert );
			}
			else
			{
				$insert[ 'newsstory_previous_story' ] = "";
			}
			
			$query = $database -> dbquery( "SELECT newsstory_title, newsstory_seo FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_id > '" . $id . "' AND " . $newsstory_status_alt . " AND (newsstory_website = '0' OR newsstory_website = '" . intval( $config[ 'WEBSITE' ] ) . "') ORDER BY newsstory_id LIMIT 1" );
			
			if( $database -> dbrows( $query ) )
			{
				list( $next_title, $next_seo ) = $database -> dbrow( $query );
				$insert[ 'newsstory_nav_seo' ] = $next_seo;
				$insert[ 'newsstory_nav_title' ] = htmlspecialchars( $next_title );
				$insert[ 'newsstory_next_story' ] = $templates -> exectemplate( $main_templates[ 'news_story_extended_nav_next_html' ], $main_templates[ 'news_story_extended_nav_next_php' ], $insert );
			}
			else
			{
				$insert[ 'newsstory_next_story' ] = "";
			}
			
			$insert[ 'newsstory_current_story' ] = $insert[ 'newsstory_title' ];
			$insert[ 'news_story_extended_nav' ] = $templates -> exectemplate( $main_templates[ 'news_story_extended_nav_html' ], $main_templates[ 'news_story_extended_nav_php' ], $insert );
		}
		
		$insert[ 'news_story_comment_pagenav' ] = "";
		$insert[ 'news_story_comment_manage_header' ] = "";
		$insert[ 'news_story_comment' ] = "";
		$insert[ 'news_story_comment_manage_footer' ] = "";
		
		if( $preferences[ 'news_forum_comments' ] and $insert[ 'newsstory_thread' ] )
		{
			$news_all_comments = $insert[ 'newsstory_comments' ];
			$news_user_array = $uwrapper -> getcommentsusers( $insert[ 'newsstory_thread' ] );
		}
		else
		{
			if( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
			{
				$newscomment_status = "newscomment_story = '" . $id . "'";
			}
			elseif( $user[ 'user_status' ] == 4 )
			{
				$newscomment_status = "newscomment_story = '" . $id . "' AND (newscomment_plonk = '" . intval( $user[ 'user_id' ] ) . "' OR newscomment_plonk = '0')";
			}
			else
			{
				$newscomment_status = "newscomment_story = '" . $id . "' AND newscomment_plonk = '0'";
			}
			
			$query = $database -> dbquery( "SELECT newscomment_authorid FROM " . DB_PREFIX . "esselbach_ct_newscomments WHERE " . $newscomment_status );
			$news_all_comments = $database -> dbrows( $query );
		}
		
		if( $news_all_comments )
		{
			$news_profile_array = array();
			$news_usertitle_title_array = array();
			$news_usertitle_posts_array = array();
			$news_comments_pages = ceil( $news_all_comments / $preferences[ 'news_max_comments' ] );
			
			if( !isset( $news_user_array ) )
			{
				$news_user_array = array();
				
				while( list( $news_user_id ) = $database -> dbrow( $query ) )
				{
					$news_user_array[ ] = "'" . intval( $news_user_id ) . "'";
				}
			}
			
			$news_profile_array = $uwrapper -> getprofilesfromarray( $news_user_array );
			
			if( $opt )
			{
				$news_comments_dbpage = $opt - 1;
				$news_comments_page = $news_comments_dbpage * $preferences[ 'news_max_comments' ];
			}
			else
			{
				$news_comments_page = 0;
			}
			
			$query = $database -> dbquery( "SELECT usertitle_title, usertitle_posts FROM " . DB_PREFIX . "esselbach_ct_userstitles ORDER BY usertitle_posts" );
			
			while( list( $usertitle_title, $usertitle_posts ) = $database -> dbrow( $query ) )
			{
				$news_usertitle_title_array[ ] = $usertitle_title;
				$news_usertitle_posts_array[ ] = $usertitle_posts;
			}
			
			if( $preferences[ 'news_allow_msgicons' ] )
			{
				$news_messageicons = array();
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons" );
				
				while( list( $messageicon_id, $messageicon_image ) = $database -> dbrow( $query ) )
				{
					$news_messageicons[ $messageicon_id ] = $messageicon_image;
				}
			}
			
			if( $preferences[ 'news_forum_comments' ] and $insert[ 'newsstory_thread' ] )
			{
				$news_comments = $uwrapper -> getcommentpage( $insert[ 'newsstory_thread' ], $news_comments_page, $preferences[ 'news_max_comments' ] );
			}
			else
			{
				$query = $database -> dbquery( "SELECT newscomment_id, newscomment_authorid, newscomment_author, newscomment_icon, newscomment_subject, newscomment_rawtext, newscomment_text, newscomment_plonk, newscomment_signature, newscomment_smilies, newscomment_bcode, newscomment_date, newscomment_edits, newscomment_lasteditauthor, newscomment_lasteditdate, newscomment_postip, newscomment_editip FROM " . DB_PREFIX . "esselbach_ct_newscomments WHERE " . $newscomment_status . " LIMIT " . $news_comments_page . "," . $preferences[ 'news_max_comments' ] );
				$news_comments = $database -> dbrows( $query );
			}
			
			if( $news_comments )
			{
				if( ( $news_comments_page < $news_all_comments ) and( $news_comments_pages > 1 ) )
				{
					$insert[ 'newscomment_totalpages' ] = $news_comments_pages;
					$insert[ 'news_story_comment_pagenav' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_header_html' ], $main_templates[ 'news_story_comment_pagenav_header_php' ], $insert );
					
					if( !$opt )
					{
						$opt = 1;
					}
					
					if( $news_comments_pages > 6 )
					{
						$news_comments_pages_new = $opt + 1;
						$news_comments_pages_old = $opt - 1;
						
						if( $news_comments_pages_new < 3 )
						{
							$news_comments_pages_cur = 3;
						}
						else
						{
							$news_comments_pages_cur = $news_comments_pages_new;
						}
						
						if( $opt > 2 )
						{
							$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_first_html' ], $main_templates[ 'news_story_comment_pagenav_first_php' ], $insert );
						}
						
						$current = $news_comments_pages_cur - 2;
						$forward = $current + 4;
						$backward = $news_comments_pages - 3;
						
						if( $forward > $news_comments_pages )
						{
							$insert[ 'newscomment_previous' ] = $insert[ 'newsstory_seo' ];
							
							if( $news_comments_pages_old != 1 )
							{
								$insert[ 'newscomment_previous' ] .= "," . $news_comments_pages_old;
							}
							
							$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_previous_html' ], $main_templates[ 'news_story_comment_pagenav_previous_php' ], $insert );
							
							for( $i = $backward; $i <= $news_comments_pages; $i++ )
							{
								$insert[ 'newscomment_page' ] = $i;
								
								if( $opt == $i )
								{
									$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_selected_html' ], $main_templates[ 'news_story_comment_pagenav_selected_php' ], $insert );
								}
								else
								{
									$insert[ 'newscomment_link' ] = $insert[ 'newsstory_seo' ];
									
									if( $i != 1 )
									{
										$insert[ 'newscomment_link' ] .= "," . $i;
									}
									
									$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_link_html' ], $main_templates[ 'news_story_comment_pagenav_link_php' ], $insert );
								}
							}
						}
						else
						{
							if( $news_comments_pages_old > 3 )
							{
								$insert[ 'newscomment_previous' ] = $insert[ 'newsstory_seo' ];
								
								if( $news_comments_pages_old != 1 )
								{
									$insert[ 'newscomment_previous' ] .= "," . $news_comments_pages_old;
								}
								
								$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_previous_html' ], $main_templates[ 'news_story_comment_pagenav_previous_php' ], $insert );
							}
							
							for( $i = $current; $i < $forward; $i++ )
							{
								$insert[ 'newscomment_page' ] = $i;
								
								if( $opt == $i )
								{
									$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_selected_html' ], $main_templates[ 'news_story_comment_pagenav_selected_php' ], $insert );
								}
								else
								{
									$insert[ 'newscomment_link' ] = $insert[ 'newsstory_seo' ];
									
									if( $i != 1 )
									{
										$insert[ 'newscomment_link' ] .= "," . $i;
									}
									
									$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_link_html' ], $main_templates[ 'news_story_comment_pagenav_link_php' ], $insert );
								}
							}
							
							$insert[ 'newscomment_next' ] = $insert[ 'newsstory_seo' ] . "," . $news_comments_pages_new;
							$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_next_html' ], $main_templates[ 'news_story_comment_pagenav_next_php' ], $insert );
							$insert[ 'newscomment_last' ] = $insert[ 'newsstory_seo' ] . "," . $news_comments_pages;
							$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_last_html' ], $main_templates[ 'news_story_comment_pagenav_last_php' ], $insert );
						}
					}
					else
					{
						for( $i = 1; $i <= $news_comments_pages; $i++ )
						{
							$insert[ 'newscomment_page' ] = $i;
							$insert[ 'newscomment_link' ] = $insert[ 'newsstory_seo' ];
							
							if( $i != 1 )
							{
								$insert[ 'newscomment_link' ] .= "," . $i;
							}
							
							if( $news_comments_page == $i )
							{
								$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_selected_html' ], $main_templates[ 'news_story_comment_pagenav_selected_php' ], $insert );
							}
							else
							{
								$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_link_html' ], $main_templates[ 'news_story_comment_pagenav_link_php' ], $insert );
							}
						}
					}
					
					$insert[ 'news_story_comment_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_pagenav_footer_html' ], $main_templates[ 'news_story_comment_pagenav_footer_php' ], $insert );
				}
				
				$newscomment_id_array = array();
				$newscomment_authorid_array = array();
				$newscomment_author_array = array();
				$newscomment_icon_array = array();
				$newscomment_subject_array = array();
				$newscomment_rawtext_array = array();
				$newscomment_text_array = array();
				$newscomment_plonk_array = array();
				$newscomment_signature_array = array();
				$newscomment_smilies_array = array();
				$newscomment_bcode_array = array();
				$newscomment_date_array = array();
				$newscomment_edits_array = array();
				$newscomment_lasteditauthor_array = array();
				$newscomment_lasteditdate_array = array();
				$newscomment_postip_array = array();
				$newscomment_editip_array = array();
				$moderator = 0;
				
				if( $preferences[ 'news_forum_comments' ] and $insert[ 'newsstory_thread' ] )
				{
					$newscomments = $uwrapper -> getcommentspage( $insert[ 'newsstory_thread' ], $news_comments_page, $preferences[ 'news_max_comments' ] );
					
					foreach( $newscomments as $newscomment )
					{
						$newscomment_data = explode( "|^Z|", $newscomment );
						
						if( !$system -> decode( $newscomment_data[ 4 ] ) )
						{
							$newscomment_subject_array[ ] = $insert[ 'newsstory_title' ];
						}
						else
						{
							$newscomment_subject_array[ ] = base64_decode( $newscomment_data[ 4 ] );
						}
						
						$newscomment_id_array[ ] = base64_decode( $newscomment_data[ 0 ] );
						$newscomment_authorid_array[ ] = base64_decode( $newscomment_data[ 1 ] );
						$newscomment_author_array[ ] = base64_decode( $newscomment_data[ 2 ] );
						$newscomment_icon_array[ ] = base64_decode( $newscomment_data[ 3 ] );
						$newscomment_rawtext_array[ ] = base64_decode( $newscomment_data[ 5 ] );
						$newscomment_text_array[ ] = base64_decode( $newscomment_data[ 6 ] );
						$newscomment_plonk_array[ ] = base64_decode( $newscomment_data[ 7 ] );
						$newscomment_signature_array[ ] = base64_decode( $newscomment_data[ 8 ] );
						$newscomment_smilies_array[ ] = base64_decode( $newscomment_data[ 9 ] );
						$newscomment_bcode_array[ ] = base64_decode( $newscomment_data[ 10 ] );
						$newscomment_date_array[ ] = base64_decode( $newscomment_data[ 11 ] );
						$newscomment_edits_array[ ] = base64_decode( $newscomment_data[ 12 ] );
						$newscomment_lasteditauthor_array[ ] = base64_decode( $newscomment_data[ 13 ] );
						$newscomment_lasteditdate_array[ ] = base64_decode( $newscomment_data[ 14 ] );
						$newscomment_postip_array[ ] = base64_decode( $newscomment_data[ 15 ] );
						$newscomment_editip_array[ ] = base64_decode( $newscomment_data[ 16 ] );
					}
				}
				else
				{
					if( $user[ 'user_status' ] == 3 and $preferences[ 'news_allow_moderators' ] )
					{
						$moderator = 1;
					}
					
					if( $user[ 'user_status' ] == 2 or $moderator )
					{
						$insert[ 'news_story_comment_manage_header' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_manage_header_html' ], $main_templates[ 'news_story_comment_manage_header_php' ], $insert );
					}
					
					while( list( $newscomment_id, $newscomment_authorid, $newscomment_author, $newscomment_icon, $newscomment_subject, $newscomment_rawtext, $newscomment_text, $newscomment_plonk, $newscomment_signature, $newscomment_smilies, $newscomment_bcode, $newscomment_date, $newscomment_edits, $newscomment_lasteditauthor, $newscomment_lasteditdate, $newscomment_postip, $newscomment_editip ) = $database -> dbrow( $query ) )
					{
						$newscomment_id_array[ ] = $newscomment_id;
						$newscomment_authorid_array[ ] = $newscomment_authorid;
						$newscomment_author_array[ ] = $newscomment_author;
						$newscomment_icon_array[ ] = $newscomment_icon;
						$newscomment_subject_array[ ] = $newscomment_subject;
						$newscomment_rawtext_array[ ] = $newscomment_rawtext;
						$newscomment_text_array[ ] = $newscomment_text;
						$newscomment_plonk_array[ ] = $newscomment_plonk;
						$newscomment_signature_array[ ] = $newscomment_signature;
						$newscomment_smilies_array[ ] = $newscomment_smilies;
						$newscomment_bcode_array[ ] = $newscomment_bcode;
						$newscomment_date_array[ ] = $newscomment_date;
						$newscomment_edits_array[ ] = $newscomment_edits;
						$newscomment_lasteditauthor_array[ ] = $newscomment_lasteditauthor;
						$newscomment_lasteditdate_array[ ] = $newscomment_lasteditdate;
						$newscomment_postip_array[ ] = $newscomment_postip;
						$newscomment_editip_array[ ] = $newscomment_editip;
					}
				}
				
				for( $c = 0; $c < count( $newscomment_id_array ); $c++ )
				{
					$insert[ 'newscomment_id' ] = intval( $newscomment_id_array[ $c ] );
					$insert[ 'newscomment_authorid' ] = intval( $newscomment_authorid_array[ $c ] );
					$insert[ 'newscomment_author' ] = htmlspecialchars( $newscomment_author_array[ $c ] );
					$insert[ 'newscomment_icon' ] = intval( $newscomment_icon_array[ $c ] );
					$insert[ 'newscomment_subject' ] = htmlspecialchars( $newscomment_subject_array[ $c ] );
					$insert[ 'newscomment_rawtext' ] = htmlspecialchars( $newscomment_rawtext_array[ $c ] );
					$insert[ 'newscomment_text' ] = $newscomment_text_array[ $c ];
					$insert[ 'newscomment_plonk' ] = intval( $newscomment_plonk_array[ $c ] );
					$insert[ 'newscomment_signature' ] = intval( $newscomment_signature_array[ $c ] );
					$insert[ 'newscomment_smilies' ] = intval( $newscomment_smilies_array[ $c ] );
					$insert[ 'newscomment_bcode' ] = intval( $newscomment_bcode_array[ $c ] );
					$insert[ 'newscomment_edits' ] = intval( $newscomment_edits_array[ $c ] );
					$insert[ 'newscomment_lasteditauthor' ] = htmlspecialchars( $newscomment_lasteditauthor_array[ $c ] );
					$insert[ 'newscomment_lasteditdate' ] = htmlspecialchars( $newscomment_lasteditdate_array[ $c ] );
					$insert[ 'newscomment_postip' ] = htmlspecialchars( $newscomment_postip_array[ $c ] );
					$insert[ 'newscomment_editip' ] = htmlspecialchars( $newscomment_editip_array[ $c ] );
					$insert[ 'newscomment_date' ] = $system -> convertdate( $newscomment_date_array[ $c ], $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );
					
					if( isset( $news_profile_array[ $insert[ 'newscomment_authorid' ] ] ) )
					{
						$newscomment_author = explode( "|^Z|", $news_profile_array[ $insert[ 'newscomment_authorid' ] ] );
						$newscomment_author_regdate = explode( " ", $newscomment_author[ 2 ] );
						$insert[ 'newscomment_author' ] = $system -> decode( $newscomment_author[ 0 ] );
						$insert[ 'newscomment_author_status' ] = $newscomment_author[ 1 ];
						$insert[ 'newscomment_author_regdate' ] = $newscomment_author_regdate[ 0 ];
						$insert[ 'newscomment_author_posts' ] = $newscomment_author[ 3 ];
						$insert[ 'newscomment_author_birthday' ] = $newscomment_author[ 4 ];
						$insert[ 'newscomment_author_location' ] = $system -> decode( $newscomment_author[ 5 ] );
						$insert[ 'newscomment_author_avatar' ] = $newscomment_author[ 6 ];
						$insert[ 'newscomment_author_signature' ] = $system -> decode( $newscomment_author[ 7 ] );
						$insert[ 'newscomment_author_title' ] = $system -> decode( $newscomment_author[ 8 ] );
						$insert[ 'newscomment_author_regip' ] = $newscomment_author[ 9 ];
						$insert[ 'newscomment_author_usertitle' ] = "";
						
						if ($insert[ 'newscomment_author_title' ])
						{
							$insert[ 'newscomment_author_usertitle' ] = $insert[ 'newscomment_author_title' ];
						}
						else 
						{
							for( $i = 0; $i < count( $news_usertitle_title_array ); $i++ )
							{
								if( $newscomment_author[ 3 ] >= $news_usertitle_posts_array[ $i ] )
								{
									$insert[ 'newscomment_author_usertitle' ] = $news_usertitle_title_array[ $i ];
								}
							}
						}
						
						$insert[ 'newscomment_author_postsline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_userposts_html' ], $main_templates[ 'news_story_comment_userposts_php' ], $insert );
						
						if( $insert[ 'newscomment_author_regdate' ] )
						{
							$insert[ 'newscomment_author_regdateline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_userregdate_html' ], $main_templates[ 'news_story_comment_userregdate_php' ], $insert );
						}
						else
						{
							$insert[ 'newscomment_author_locationline' ] = "";
						}
						
						if( $insert[ 'newscomment_author_location' ] )
						{
							$insert[ 'newscomment_author_locationline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_userlocation_html' ], $main_templates[ 'news_story_comment_userlocation_php' ], $insert );
						}
						else
						{
							$insert[ 'newscomment_author_locationline' ] = "";
						}
						
						if( $newscomment_author[ 1 ] == 1 or $newscomment_author[ 1 ] == 4 )
						{
							$insert[ 'newscomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_usertitle_html' ], $main_templates[ 'news_story_comment_usertitle_php' ], $insert );
						}
						elseif( $newscomment_author[ 1 ] == 2 )
						{
							$insert[ 'newscomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_usertitle_admin_html' ], $main_templates[ 'news_story_comment_usertitle_admin_php' ], $insert );
						}
						elseif( $newscomment_author[ 1 ] == 3 )
						{
							$insert[ 'newscomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_usertitle_moderator_html' ], $main_templates[ 'news_story_comment_usertitle_moderator_php' ], $insert );
						}
						elseif( $newscomment_author[ 1 ] == 5 )
						{
							$insert[ 'newscomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_usertitle_banned_html' ], $main_templates[ 'news_story_comment_usertitle_banned_php' ], $insert );
						}
						elseif( $newscomment_author[ 1 ] == 6 )
						{
							$insert[ 'newscomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_usertitle_subscriber_html' ], $main_templates[ 'news_story_comment_usertitle_subscriber_php' ], $insert );
						}
					}
					else
					{
						$insert[ 'newscomment_author_status' ] = "";
						$insert[ 'newscomment_author_regdate' ] = "";
						$insert[ 'newscomment_author_posts' ] = "";
						$insert[ 'newscomment_author_birthday' ] = "";
						$insert[ 'newscomment_author_location' ] = "";
						$insert[ 'newscomment_author_avatar' ] = "";
						$insert[ 'newscomment_author_signature' ] = "";
						$insert[ 'newscomment_author_title' ] = "";
						$insert[ 'newscomment_author_regip' ] = "";
						$insert[ 'newscomment_author_titleline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_usertitle_anon_html' ], $main_templates[ 'news_story_comment_usertitle_anon_php' ], $insert );
						$insert[ 'newscomment_author_postsline' ] = "";
						$insert[ 'newscomment_author_regdateline' ] = "";
						$insert[ 'newscomment_author_locationline' ] = "";
					}
					
					if( $insert[ 'newscomment_author_avatar' ] )
					{
						$insert[ 'newscomment_author_avatarline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_avatar_html' ], $main_templates[ 'news_story_comment_avatar_php' ], $insert );
					}
					else
					{
						$insert[ 'newscomment_author_avatarline' ] = "";
					}
					
					if( $insert[ 'newscomment_author_signature' ] and $preferences[ 'news_show_signature' ] )
					{
						$insert[ 'newscomment_author_signature' ] = $system -> smilies( $system -> code( $insert[ 'newscomment_author_signature' ] ) );
						$insert[ 'newscomment_author_signatureline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_signature_html' ], $main_templates[ 'news_story_comment_signature_php' ], $insert );
					}
					else
					{
						$insert[ 'newscomment_author_signatureline' ] = "";
					}
					
					if( $user[ 'user_status' ] and $insert[ 'newscomment_authorid' ] )
					{
						$insert[ 'newscomment_authorline' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_profile_html' ], $main_templates[ 'news_story_comment_profile_php' ], $insert );
					}
					else
					{
						$insert[ 'newscomment_authorline' ] = $insert[ 'newscomment_author' ];
					}
					
					if( $preferences[ 'news_allow_msgicons' ] and isset( $news_messageicons[ $insert[ 'newscomment_icon' ] ] ) )
					{
						$insert[ 'newscomment_messageicon' ] = $news_messageicons[ $insert[ 'newscomment_icon' ] ];
						$insert[ 'newscomment_messageicon' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_messageicon_html' ], $main_templates[ 'news_story_comment_messageicon_php' ], $insert );
					}
					else
					{
						$insert[ 'newscomment_messageicon' ] = "";
					}
					
					if( $user[ 'user_status' ] and !$insert[ 'newsstory_thread' ] )
					{
						$insert[ 'newscomment_rawtext' ] = $system -> fixbreaks( addslashes( $insert[ 'newscomment_rawtext' ] ) );
						
						if( $user[ 'user_status' ] == 2 or $moderator )
						{
							$insert[ 'newscomment_options' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_options_admin_html' ], $main_templates[ 'news_story_comment_options_admin_php' ], $insert );
						}
						else
						{
							if( $user[ 'user_name' ] == $insert[ 'newscomment_author' ] )
							{
								$insert[ 'newscomment_options_edit' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_options_edit_html' ], $main_templates[ 'news_story_comment_options_edit_php' ], $insert );
							}
							else
							{
								$insert[ 'newscomment_options_edit' ] = "";
							}
							
							$insert[ 'newscomment_options' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_options_html' ], $main_templates[ 'news_story_comment_options_php' ], $insert );
						}
					}
					else
					{
						$insert[ 'newscomment_options' ] = "";
					}
					
					if( ( !$insert[ 'newscomment_plonk' ] ) or( $user[ 'user_status' ] == 4 and $insert[ 'newscomment_plonk' ] ) )
					{
						$insert[ 'news_story_comment' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_html' ], $main_templates[ 'news_story_comment_php' ], $insert );
					}
					else
					{
						$insert[ 'news_story_comment' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_plonked_html' ], $main_templates[ 'news_story_comment_plonked_php' ], $insert );
					}
				}
				
				if( ( $user[ 'user_status' ] == 2 or $moderator ) and( !$insert[ 'newsstory_thread' ] ) )
				{
					$insert[ 'news_story_comment_manage_footer' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_manage_footer_html' ], $main_templates[ 'news_story_comment_manage_footer_php' ], $insert );
				}
			}
		}
		
		if( $insert[ 'newsstory_thread' ] )
		{
			$insert[ 'newsstory_threadlink' ] = $uwrapper -> getthreadlink( $insert[ 'newsstory_thread' ] );
			$insert[ 'news_story_comment_form' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_form_external_html' ], $main_templates[ 'news_story_comment_form_external_php' ], $insert );
		}
		else
		{
			$insert[ 'input_anon' ] = "";
			$insert[ 'input_subject' ] = "";
			$insert[ 'input_message' ] = "";
			
			if( $preferences[ 'news_allow_unregcomments' ] and !$user[ 'user_status' ] )
			{
				$insert[ 'newsstory_anon' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_form_anon_html' ], $main_templates[ 'news_story_comment_form_anon_php' ], $insert );
			}
			else
			{
				$insert[ 'newsstory_anon' ] = "";
			}
			
			if( $preferences[ 'news_allow_msgicons' ] )
			{
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_name, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons WHERE messageicon_active = '1' ORDER BY messageicon_position" );
				$messageicon_row = 0;
				$insert[ 'newsstory_iconrow' ] = "";
				
				while( list( $insert[ 'messageicon_id' ], $insert[ 'messageicon_name' ], $insert[ 'messageicon_image' ] ) = $database -> dbrow( $query ) )
				{
					$insert[ 'messageicon_name' ] = htmlspecialchars( $insert[ 'messageicon_name' ] );
					$insert[ 'messageicon_image' ] = htmlspecialchars( $insert[ 'messageicon_image' ] );
					
					if( !$messageicon_row )
					{
						$insert[ 'messageicon_checked' ] = "checked=\"checked\"";
					}
					else
					{
						$insert[ 'messageicon_checked' ] = "";
					}
					
					$messageicon_row++;
					
					if( $messageicon_row > $preferences[ 'news_max_msgicons' ] )
					{
						$insert[ 'messageicon_break' ] = "<br />";
						$messageicon_row = 1;
					}
					else
					{
						$insert[ 'messageicon_break' ] = "";
					}
					
					$insert[ 'newsstory_iconrow' ] .= $templates -> exectemplate( $main_templates[ 'news_story_comment_form_iconrow_html' ], $main_templates[ 'news_story_comment_form_iconrow_php' ], $insert );
				}
			}
			
			if( $insert[ 'newsstory_iconrow' ] )
			{
				$insert[ 'newsstory_icon' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_form_icon_html' ], $main_templates[ 'news_story_comment_form_icon_php' ], $insert );
			}
			else
			{
				$insert[ 'newsstory_icon' ] = "";
			}
			
			if( ( $user[ 'user_status' ] or $preferences[ 'news_allow_unregcomments' ] ) and $insert[ 'newsstory_allowcomments' ] )
			{
				if( $user[ 'user_status' ] )
				{
					$input_signature = $uwrapper -> signature( $input_author );
					( $input_signature ) ? $insert[ 'input_signature_checked' ] = "checked=\"checked\"" : $insert[ 'input_signature_checked' ] = "" ;
					$insert[ 'newsstory_signature' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_form_signature_html' ], $main_templates[ 'news_story_comment_form_signature_php' ], $insert );
				}
				else
				{
					$input_signature = 0;
					$insert[ 'newsstory_signature' ] = "";
				}
				
				$insert[ 'input_smilies_checked' ] = "";
				$insert[ 'input_bcode_checked' ] = "";
				
				if( $preferences[ 'news_securitycode' ] and function_exists( "imagestring" ) )
				{
					$insert[ 'input_securitycode' ] = "";
					
					if( !isset( $_SESSION[ 'news_security_code' ] ) )
					{
						session_start();
						$_SESSION[ 'news_security_code' ] = substr( md5( rand( 1, 32768 ) ), 14, 8 );
					}
					
					$insert[ 'newsstory_securitycode' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_form_securitycode_html' ], $main_templates[ 'news_story_comment_form_securitycode_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_securitycode' ] = "";
				}
				
				$insert[ 'news_story_comment_form' ] = $templates -> exectemplate( $main_templates[ 'news_story_comment_form_html' ], $main_templates[ 'news_story_comment_form_php' ], $insert );
			}
			else
			{
				$insert[ 'news_story_comment_form' ] = "";
			}
		}
	}
	else
	{
		if( isset( $newsstory_notice ) )
		{
			echo $newsstory_notice;
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'news_story_error_nostory_html' ], $main_templates[ 'news_story_error_nostory_php' ], $insert );
		}
	}
	
	if( $preferences[ 'news_navigation' ] )
	{
		if( $news_story )
		{
			$insert[ 'news_story_footer' ] = $templates -> exectemplate( $main_templates[ 'news_story_footer_html' ], $main_templates[ 'news_story_footer_php' ], $insert );
		}
		else
		{
			echo $templates -> exectemplate( $main_templates[ 'news_header_html' ], $main_templates[ 'news_header_php' ], $insert );
		}
	}
	
	if( $news_story )
	{
		echo $templates -> exectemplate( $main_templates[ 'news_layout_extended_story_html' ], $main_templates[ 'news_layout_extended_story_php' ], $insert );
	}
	
	if( $preferences[ 'news_alt_site_header' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_footer_alt_html' ], $main_templates[ 'site_footer_alt_php' ], $insert );
	}
	else
	{
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
	}
}
?>